#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

void ATL_dJIK64x64x64TT0x0x0_aX_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=T, MB=64, NB=64, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=8, nu=2, ku=64, pf=513
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.8.4)
 */
{
   const double *stM = A + (((lda) << 6));
   const double *stN = B + 64;
   const double *pfA = A + M;
   const double BetaAlpha = beta / alpha;
   #define incAk 64
   const int incAm = ((((lda) << 3)) - 64), incAn = -(((lda) << 6));
   const int incBk = (ldb), incBm = -(((ldb) << 6));
   #define incBn 2
   #define incCm 8
   const int incCn = (((ldc) << 1)) - 64;
   double *pC0=C, *pC1=pC0+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda), *pA7=pA6+(lda);
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6, rA7;
   register double rB0, rB1;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC7_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC7_1;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      ATL_pfl1R(pfA+48);
      ATL_pfl1R(pfA+56);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rA4 = *pA4;
         rA5 = *pA5;
         rA6 = *pA6;
         rA7 = *pA7;
         rC0_0 = rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 = rA1 * rB0;
         rC2_0 = rA2 * rB0;
         rC3_0 = rA3 * rB0;
         rC4_0 = rA4 * rB0;
         rC5_0 = rA5 * rB0;
         rC6_0 = rA6 * rB0;
         rC7_0 = rA7 * rB0;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC3_1 = rA3 * rB1;
         rC4_1 = rA4 * rB1;
         rC5_1 = rA5 * rB1;
         rC6_1 = rA6 * rB1;
         rC7_1 = rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[1];
         rB0 = *pB0;
         rA1 = pA1[1];
         rA2 = pA2[1];
         rA3 = pA3[1];
         rA4 = pA4[1];
         rA5 = pA5[1];
         rA6 = pA6[1];
         rA7 = pA7[1];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[2];
         rB0 = *pB0;
         rA1 = pA1[2];
         rA2 = pA2[2];
         rA3 = pA3[2];
         rA4 = pA4[2];
         rA5 = pA5[2];
         rA6 = pA6[2];
         rA7 = pA7[2];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[3];
         rB0 = *pB0;
         rA1 = pA1[3];
         rA2 = pA2[3];
         rA3 = pA3[3];
         rA4 = pA4[3];
         rA5 = pA5[3];
         rA6 = pA6[3];
         rA7 = pA7[3];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[4];
         rB0 = *pB0;
         rA1 = pA1[4];
         rA2 = pA2[4];
         rA3 = pA3[4];
         rA4 = pA4[4];
         rA5 = pA5[4];
         rA6 = pA6[4];
         rA7 = pA7[4];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[5];
         rB0 = *pB0;
         rA1 = pA1[5];
         rA2 = pA2[5];
         rA3 = pA3[5];
         rA4 = pA4[5];
         rA5 = pA5[5];
         rA6 = pA6[5];
         rA7 = pA7[5];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[6];
         rB0 = *pB0;
         rA1 = pA1[6];
         rA2 = pA2[6];
         rA3 = pA3[6];
         rA4 = pA4[6];
         rA5 = pA5[6];
         rA6 = pA6[6];
         rA7 = pA7[6];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[7];
         rB0 = *pB0;
         rA1 = pA1[7];
         rA2 = pA2[7];
         rA3 = pA3[7];
         rA4 = pA4[7];
         rA5 = pA5[7];
         rA6 = pA6[7];
         rA7 = pA7[7];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[8];
         rB0 = *pB0;
         rA1 = pA1[8];
         rA2 = pA2[8];
         rA3 = pA3[8];
         rA4 = pA4[8];
         rA5 = pA5[8];
         rA6 = pA6[8];
         rA7 = pA7[8];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[9];
         rB0 = *pB0;
         rA1 = pA1[9];
         rA2 = pA2[9];
         rA3 = pA3[9];
         rA4 = pA4[9];
         rA5 = pA5[9];
         rA6 = pA6[9];
         rA7 = pA7[9];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[10];
         rB0 = *pB0;
         rA1 = pA1[10];
         rA2 = pA2[10];
         rA3 = pA3[10];
         rA4 = pA4[10];
         rA5 = pA5[10];
         rA6 = pA6[10];
         rA7 = pA7[10];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[11];
         rB0 = *pB0;
         rA1 = pA1[11];
         rA2 = pA2[11];
         rA3 = pA3[11];
         rA4 = pA4[11];
         rA5 = pA5[11];
         rA6 = pA6[11];
         rA7 = pA7[11];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[12];
         rB0 = *pB0;
         rA1 = pA1[12];
         rA2 = pA2[12];
         rA3 = pA3[12];
         rA4 = pA4[12];
         rA5 = pA5[12];
         rA6 = pA6[12];
         rA7 = pA7[12];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[13];
         rB0 = *pB0;
         rA1 = pA1[13];
         rA2 = pA2[13];
         rA3 = pA3[13];
         rA4 = pA4[13];
         rA5 = pA5[13];
         rA6 = pA6[13];
         rA7 = pA7[13];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[14];
         rB0 = *pB0;
         rA1 = pA1[14];
         rA2 = pA2[14];
         rA3 = pA3[14];
         rA4 = pA4[14];
         rA5 = pA5[14];
         rA6 = pA6[14];
         rA7 = pA7[14];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[15];
         rB0 = *pB0;
         rA1 = pA1[15];
         rA2 = pA2[15];
         rA3 = pA3[15];
         rA4 = pA4[15];
         rA5 = pA5[15];
         rA6 = pA6[15];
         rA7 = pA7[15];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[16];
         rB0 = *pB0;
         rA1 = pA1[16];
         rA2 = pA2[16];
         rA3 = pA3[16];
         rA4 = pA4[16];
         rA5 = pA5[16];
         rA6 = pA6[16];
         rA7 = pA7[16];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[17];
         rB0 = *pB0;
         rA1 = pA1[17];
         rA2 = pA2[17];
         rA3 = pA3[17];
         rA4 = pA4[17];
         rA5 = pA5[17];
         rA6 = pA6[17];
         rA7 = pA7[17];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[18];
         rB0 = *pB0;
         rA1 = pA1[18];
         rA2 = pA2[18];
         rA3 = pA3[18];
         rA4 = pA4[18];
         rA5 = pA5[18];
         rA6 = pA6[18];
         rA7 = pA7[18];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[19];
         rB0 = *pB0;
         rA1 = pA1[19];
         rA2 = pA2[19];
         rA3 = pA3[19];
         rA4 = pA4[19];
         rA5 = pA5[19];
         rA6 = pA6[19];
         rA7 = pA7[19];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[20];
         rB0 = *pB0;
         rA1 = pA1[20];
         rA2 = pA2[20];
         rA3 = pA3[20];
         rA4 = pA4[20];
         rA5 = pA5[20];
         rA6 = pA6[20];
         rA7 = pA7[20];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[21];
         rB0 = *pB0;
         rA1 = pA1[21];
         rA2 = pA2[21];
         rA3 = pA3[21];
         rA4 = pA4[21];
         rA5 = pA5[21];
         rA6 = pA6[21];
         rA7 = pA7[21];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[22];
         rB0 = *pB0;
         rA1 = pA1[22];
         rA2 = pA2[22];
         rA3 = pA3[22];
         rA4 = pA4[22];
         rA5 = pA5[22];
         rA6 = pA6[22];
         rA7 = pA7[22];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[23];
         rB0 = *pB0;
         rA1 = pA1[23];
         rA2 = pA2[23];
         rA3 = pA3[23];
         rA4 = pA4[23];
         rA5 = pA5[23];
         rA6 = pA6[23];
         rA7 = pA7[23];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[24];
         rB0 = *pB0;
         rA1 = pA1[24];
         rA2 = pA2[24];
         rA3 = pA3[24];
         rA4 = pA4[24];
         rA5 = pA5[24];
         rA6 = pA6[24];
         rA7 = pA7[24];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[25];
         rB0 = *pB0;
         rA1 = pA1[25];
         rA2 = pA2[25];
         rA3 = pA3[25];
         rA4 = pA4[25];
         rA5 = pA5[25];
         rA6 = pA6[25];
         rA7 = pA7[25];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[26];
         rB0 = *pB0;
         rA1 = pA1[26];
         rA2 = pA2[26];
         rA3 = pA3[26];
         rA4 = pA4[26];
         rA5 = pA5[26];
         rA6 = pA6[26];
         rA7 = pA7[26];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[27];
         rB0 = *pB0;
         rA1 = pA1[27];
         rA2 = pA2[27];
         rA3 = pA3[27];
         rA4 = pA4[27];
         rA5 = pA5[27];
         rA6 = pA6[27];
         rA7 = pA7[27];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[28];
         rB0 = *pB0;
         rA1 = pA1[28];
         rA2 = pA2[28];
         rA3 = pA3[28];
         rA4 = pA4[28];
         rA5 = pA5[28];
         rA6 = pA6[28];
         rA7 = pA7[28];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[29];
         rB0 = *pB0;
         rA1 = pA1[29];
         rA2 = pA2[29];
         rA3 = pA3[29];
         rA4 = pA4[29];
         rA5 = pA5[29];
         rA6 = pA6[29];
         rA7 = pA7[29];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[30];
         rB0 = *pB0;
         rA1 = pA1[30];
         rA2 = pA2[30];
         rA3 = pA3[30];
         rA4 = pA4[30];
         rA5 = pA5[30];
         rA6 = pA6[30];
         rA7 = pA7[30];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[31];
         rB0 = *pB0;
         rA1 = pA1[31];
         rA2 = pA2[31];
         rA3 = pA3[31];
         rA4 = pA4[31];
         rA5 = pA5[31];
         rA6 = pA6[31];
         rA7 = pA7[31];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[32];
         rB0 = *pB0;
         rA1 = pA1[32];
         rA2 = pA2[32];
         rA3 = pA3[32];
         rA4 = pA4[32];
         rA5 = pA5[32];
         rA6 = pA6[32];
         rA7 = pA7[32];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[33];
         rB0 = *pB0;
         rA1 = pA1[33];
         rA2 = pA2[33];
         rA3 = pA3[33];
         rA4 = pA4[33];
         rA5 = pA5[33];
         rA6 = pA6[33];
         rA7 = pA7[33];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[34];
         rB0 = *pB0;
         rA1 = pA1[34];
         rA2 = pA2[34];
         rA3 = pA3[34];
         rA4 = pA4[34];
         rA5 = pA5[34];
         rA6 = pA6[34];
         rA7 = pA7[34];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[35];
         rB0 = *pB0;
         rA1 = pA1[35];
         rA2 = pA2[35];
         rA3 = pA3[35];
         rA4 = pA4[35];
         rA5 = pA5[35];
         rA6 = pA6[35];
         rA7 = pA7[35];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[36];
         rB0 = *pB0;
         rA1 = pA1[36];
         rA2 = pA2[36];
         rA3 = pA3[36];
         rA4 = pA4[36];
         rA5 = pA5[36];
         rA6 = pA6[36];
         rA7 = pA7[36];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[37];
         rB0 = *pB0;
         rA1 = pA1[37];
         rA2 = pA2[37];
         rA3 = pA3[37];
         rA4 = pA4[37];
         rA5 = pA5[37];
         rA6 = pA6[37];
         rA7 = pA7[37];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[38];
         rB0 = *pB0;
         rA1 = pA1[38];
         rA2 = pA2[38];
         rA3 = pA3[38];
         rA4 = pA4[38];
         rA5 = pA5[38];
         rA6 = pA6[38];
         rA7 = pA7[38];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[39];
         rB0 = *pB0;
         rA1 = pA1[39];
         rA2 = pA2[39];
         rA3 = pA3[39];
         rA4 = pA4[39];
         rA5 = pA5[39];
         rA6 = pA6[39];
         rA7 = pA7[39];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[40];
         rB0 = *pB0;
         rA1 = pA1[40];
         rA2 = pA2[40];
         rA3 = pA3[40];
         rA4 = pA4[40];
         rA5 = pA5[40];
         rA6 = pA6[40];
         rA7 = pA7[40];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[41];
         rB0 = *pB0;
         rA1 = pA1[41];
         rA2 = pA2[41];
         rA3 = pA3[41];
         rA4 = pA4[41];
         rA5 = pA5[41];
         rA6 = pA6[41];
         rA7 = pA7[41];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[42];
         rB0 = *pB0;
         rA1 = pA1[42];
         rA2 = pA2[42];
         rA3 = pA3[42];
         rA4 = pA4[42];
         rA5 = pA5[42];
         rA6 = pA6[42];
         rA7 = pA7[42];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[43];
         rB0 = *pB0;
         rA1 = pA1[43];
         rA2 = pA2[43];
         rA3 = pA3[43];
         rA4 = pA4[43];
         rA5 = pA5[43];
         rA6 = pA6[43];
         rA7 = pA7[43];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[44];
         rB0 = *pB0;
         rA1 = pA1[44];
         rA2 = pA2[44];
         rA3 = pA3[44];
         rA4 = pA4[44];
         rA5 = pA5[44];
         rA6 = pA6[44];
         rA7 = pA7[44];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[45];
         rB0 = *pB0;
         rA1 = pA1[45];
         rA2 = pA2[45];
         rA3 = pA3[45];
         rA4 = pA4[45];
         rA5 = pA5[45];
         rA6 = pA6[45];
         rA7 = pA7[45];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[46];
         rB0 = *pB0;
         rA1 = pA1[46];
         rA2 = pA2[46];
         rA3 = pA3[46];
         rA4 = pA4[46];
         rA5 = pA5[46];
         rA6 = pA6[46];
         rA7 = pA7[46];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[47];
         rB0 = *pB0;
         rA1 = pA1[47];
         rA2 = pA2[47];
         rA3 = pA3[47];
         rA4 = pA4[47];
         rA5 = pA5[47];
         rA6 = pA6[47];
         rA7 = pA7[47];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[48];
         rB0 = *pB0;
         rA1 = pA1[48];
         rA2 = pA2[48];
         rA3 = pA3[48];
         rA4 = pA4[48];
         rA5 = pA5[48];
         rA6 = pA6[48];
         rA7 = pA7[48];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[49];
         rB0 = *pB0;
         rA1 = pA1[49];
         rA2 = pA2[49];
         rA3 = pA3[49];
         rA4 = pA4[49];
         rA5 = pA5[49];
         rA6 = pA6[49];
         rA7 = pA7[49];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[50];
         rB0 = *pB0;
         rA1 = pA1[50];
         rA2 = pA2[50];
         rA3 = pA3[50];
         rA4 = pA4[50];
         rA5 = pA5[50];
         rA6 = pA6[50];
         rA7 = pA7[50];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[51];
         rB0 = *pB0;
         rA1 = pA1[51];
         rA2 = pA2[51];
         rA3 = pA3[51];
         rA4 = pA4[51];
         rA5 = pA5[51];
         rA6 = pA6[51];
         rA7 = pA7[51];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[52];
         rB0 = *pB0;
         rA1 = pA1[52];
         rA2 = pA2[52];
         rA3 = pA3[52];
         rA4 = pA4[52];
         rA5 = pA5[52];
         rA6 = pA6[52];
         rA7 = pA7[52];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[53];
         rB0 = *pB0;
         rA1 = pA1[53];
         rA2 = pA2[53];
         rA3 = pA3[53];
         rA4 = pA4[53];
         rA5 = pA5[53];
         rA6 = pA6[53];
         rA7 = pA7[53];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[54];
         rB0 = *pB0;
         rA1 = pA1[54];
         rA2 = pA2[54];
         rA3 = pA3[54];
         rA4 = pA4[54];
         rA5 = pA5[54];
         rA6 = pA6[54];
         rA7 = pA7[54];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[55];
         rB0 = *pB0;
         rA1 = pA1[55];
         rA2 = pA2[55];
         rA3 = pA3[55];
         rA4 = pA4[55];
         rA5 = pA5[55];
         rA6 = pA6[55];
         rA7 = pA7[55];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[56];
         rB0 = *pB0;
         rA1 = pA1[56];
         rA2 = pA2[56];
         rA3 = pA3[56];
         rA4 = pA4[56];
         rA5 = pA5[56];
         rA6 = pA6[56];
         rA7 = pA7[56];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[57];
         rB0 = *pB0;
         rA1 = pA1[57];
         rA2 = pA2[57];
         rA3 = pA3[57];
         rA4 = pA4[57];
         rA5 = pA5[57];
         rA6 = pA6[57];
         rA7 = pA7[57];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[58];
         rB0 = *pB0;
         rA1 = pA1[58];
         rA2 = pA2[58];
         rA3 = pA3[58];
         rA4 = pA4[58];
         rA5 = pA5[58];
         rA6 = pA6[58];
         rA7 = pA7[58];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[59];
         rB0 = *pB0;
         rA1 = pA1[59];
         rA2 = pA2[59];
         rA3 = pA3[59];
         rA4 = pA4[59];
         rA5 = pA5[59];
         rA6 = pA6[59];
         rA7 = pA7[59];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[60];
         rB0 = *pB0;
         rA1 = pA1[60];
         rA2 = pA2[60];
         rA3 = pA3[60];
         rA4 = pA4[60];
         rA5 = pA5[60];
         rA6 = pA6[60];
         rA7 = pA7[60];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[61];
         rB0 = *pB0;
         rA1 = pA1[61];
         rA2 = pA2[61];
         rA3 = pA3[61];
         rA4 = pA4[61];
         rA5 = pA5[61];
         rA6 = pA6[61];
         rA7 = pA7[61];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[62];
         rB0 = *pB0;
         rA1 = pA1[62];
         rA2 = pA2[62];
         rA3 = pA3[62];
         rA4 = pA4[62];
         rA5 = pA5[62];
         rA6 = pA6[62];
         rA7 = pA7[62];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         rA0 = pA0[63];
         rB0 = *pB0;
         rA1 = pA1[63];
         rA2 = pA2[63];
         rA3 = pA3[63];
         rA4 = pA4[63];
         rA5 = pA5[63];
         rA6 = pA6[63];
         rA7 = pA7[63];
         rC0_0 += rA0 * rB0;
         rB1 = pB0[1];
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC7_0 += rA7 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC7_1 += rA7 * rB1;
         pB0 += incBk;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
         pA6 += incAk;
         pA7 += incAk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC3_0 *= rB0;
         rC3_1 *= rB0;
         rC4_0 *= rB0;
         rC4_1 *= rB0;
         rC5_0 *= rB0;
         rC5_1 *= rB0;
         rC6_0 *= rB0;
         rC6_1 *= rB0;
         rC7_0 *= rB0;
         rC7_1 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0[6] = rC6_0;
         pC0[7] = rC7_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         pC1[5] = rC5_1;
         pC1[6] = rC6_1;
         pC1[7] = rC7_1;
         pC0 += incCm;
         pC1 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pA5 += incAm;
         pA6 += incAm;
         pA7 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pA6 += incAn;
      pA7 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
